BitMagic-C++: bm::decoder_base Class Reference

BitMagic-C++

Public Member Functions | Protected Attributes
bm::decoder_base Class Reference
Elias Gamma Code (internal)

Base class for all decoding functionality. More...

`#include <encoding.h>`

Inheritance diagram for bm::decoder_base:
[legend]

## Public Member Functions
| decoder_base (const unsigned char *buf) BMNOEXCEPT
unsigned char | get_8 () BMNOEXCEPT
| Reads character from the decoding buffer. More...
size_t | size () const BMNOEXCEPT
| Returns size of the current decoding stream. More...
void | seek (int delta) BMNOEXCEPT
| change current position More...
void | memcpy (unsigned char *dst, size_t count) BMNOEXCEPT
| read bytes from the decode buffer More...
const unsigned char * | get_pos () const BMNOEXCEPT
| Return current buffer pointer. More...
void | set_pos (const unsigned char *pos) BMNOEXCEPT
| Set current buffer pointer. More...

## Protected Attributes
const unsigned char * | buf_
const unsigned char * | start_

## Detailed Description

Base class for all decoding functionality.

Definition at line 83 of file encoding.h.

## Constructor & Destructor Documentation

## ◆ decoder_base()

bm::decoder_base::decoder_base | ( | const unsigned char * | buf | ) |
| inline

Definition at line 86 of file encoding.h.

## Member Function Documentation

## ◆ get_8()

unsigned char bm::decoder_base::get_8 | ( |  | ) |
| inline

Reads character from the decoding buffer.

Definition at line 89 of file encoding.h.

Referenced by bm::compressed_collection_deserializer< CBC >::deserialize(), bm::deserializer< bvector_type, bm::decoder >::deserialize(), bm::operation_deserializer< bvector_type >::deserialize(), bm::deserialize(), bm::operation_deserializer< bvector_type >::deserialize_range(), bm::deserialize_range(), bm::sparse_vector_deserializer< SV >::load_header(), bm::sparse_vector_deserializer< SV >::load_remap(), bm::deseriaizer_base< DEC, BV::block_idx_type >::read_gap_block(), bm::deseriaizer_base< DEC, BV::block_idx_type >::read_id_list(), and bm::deseriaizer_base< DEC, BV::block_idx_type >::try_skip().

## ◆ get_pos()

const unsigned char* bm::decoder_base::get_pos | ( |  | ) | const
| inline

Return current buffer pointer.

Definition at line 101 of file encoding.h.

Referenced by bm::compressed_collection_deserializer< CBC >::deserialize(), bm::deserializer< bvector_type, bm::decoder >::deserialize(), and bm::deseriaizer_base< DEC, BV::block_idx_type >::try_skip().

## ◆ memcpy()

void bm::decoder_base::memcpy | ( | unsigned char * | dst,
|  | size_t | count
| ) |  |
| inline

read bytes from the decode buffer

Load bytes from the decode buffer

Definition at line 618 of file encoding.h.

References bm::encoder::memcpy().

Referenced by bm::compressed_collection_deserializer< CBC >::deserialize(), and bm::sparse_vector_deserializer< SV >::load_remap().

## ◆ seek()

void bm::decoder_base::seek | ( | int | delta | ) |
| inline

change current position

Definition at line 95 of file encoding.h.

Referenced by bm::compressed_collection_deserializer< CBC >::deserialize(), bm::decoder_little_endian::get_16(), bm::decoder_little_endian::get_32(), and bm::decoder_little_endian::get_32_OR().

## ◆ set_pos()

void bm::decoder_base::set_pos | ( | const unsigned char * | pos | ) |
| inline

Set current buffer pointer.

Definition at line 104 of file encoding.h.

Referenced by bm::deseriaizer_base< DEC, BV::block_idx_type >::try_skip().

## ◆ size()

size_t bm::decoder_base::size | ( |  | ) | const
| inline

Returns size of the current decoding stream.

Definition at line 92 of file encoding.h.

Referenced by bm::deserializer< bvector_type, bm::decoder >::deserialize().

## Field Documentation

## ◆ buf_

const unsigned char* bm::decoder_base::buf_
| protected

Definition at line 106 of file encoding.h.

Referenced by bm::decoder_little_endian::get_16(), bm::decoder_little_endian::get_24(), bm::decoder_little_endian::get_32(), bm::decoder_little_endian::get_48(), and bm::decoder_little_endian::get_64().

## ◆ start_

const unsigned char* bm::decoder_base::start_
| protected

Definition at line 107 of file encoding.h.

The documentation for this class was generated from the following file:

- encoding.h